package com.konaworks.idea.inspections.javaee;

import com.intellij.codeInspection.InspectionToolProvider;
import com.intellij.openapi.components.ApplicationComponent;
import com.konaworks.idea.inspections.javaee.application.AppDuplicatesInspection;
import com.konaworks.idea.inspections.javaee.ejb.EjbJarDuplicatesInspection;
import com.konaworks.idea.inspections.javaee.ejb.EjbJarSecurityRoleReferenceInspection;
import com.konaworks.idea.inspections.javaee.ejb.EjbJarUnusedSecurityRoleInspection;
import com.konaworks.idea.inspections.javaee.web.UrlPatternInspection;
import com.konaworks.idea.inspections.javaee.web.WebAppExtraErrorDuplicatesInspection;
import com.konaworks.idea.inspections.javaee.web.WebAppSecurityRoleReferenceInspection;
import com.konaworks.idea.inspections.javaee.web.WebAppUnusedSecurityRoleInspection;
import com.konaworks.idea.inspections.javaee.web.WebAppWarningDuplicatesInspection;
import org.jetbrains.annotations.NotNull;

public class InspectionToolProviderImpl implements InspectionToolProvider, ApplicationComponent {
  public Class[] getInspectionClasses() {
    return new Class[]{
        // application
        AppDuplicatesInspection.class,
        // ejb
        EjbJarDuplicatesInspection.class,
        EjbJarSecurityRoleReferenceInspection.class,
        EjbJarUnusedSecurityRoleInspection.class,
        // web
        WebAppExtraErrorDuplicatesInspection.class,
        WebAppWarningDuplicatesInspection.class,
        WebAppSecurityRoleReferenceInspection.class,
        WebAppUnusedSecurityRoleInspection.class,
        UrlPatternInspection.class,
        // todo security-constraint structure inspection terughalen uit cvs
    };
  }

  @NotNull
  public String getComponentName() {
    return InspectionToolProviderImpl.class.getName();
  }

  public void initComponent() {
  }

  public void disposeComponent() {
  }
}
