package com.konaworks.idea.inspections.javaee.application;

import com.intellij.codeInsight.daemon.GroupNames;
import com.intellij.javaee.model.xml.application.JavaeeApplication;
import com.intellij.util.xml.DomElement;
import com.intellij.util.xml.highlighting.DomElementAnnotationHolder;
import com.intellij.util.xml.highlighting.DomElementsInspection;
import com.intellij.util.xml.highlighting.DomHighlightingHelper;
import org.jetbrains.annotations.NotNull;

public abstract class AbstractApplicationInspection extends DomElementsInspection<JavaeeApplication> {
  public AbstractApplicationInspection() {
    super(JavaeeApplication.class);
  }

  @NotNull
  public final String getGroupDisplayName() {
    return GroupNames.JAVAEE_GROUP_NAME;
  }

  public final boolean isEnabledByDefault() {
    return true;
  }

  protected void checkDomElement(DomElement element, DomElementAnnotationHolder holder, DomHighlightingHelper helper) {
    // todo rewrite subclasses to use this method. for now overwritten to prevent UnsupportedOperationException that breaks JBs generic inspections
  }
}
