package com.konaworks.idea.intentions.javaee.ejb;

import com.intellij.codeInsight.intention.IntentionAction;
import com.intellij.javaee.model.xml.ejb.EjbJar;
import com.intellij.openapi.editor.Editor;
import com.intellij.openapi.project.Project;
import com.intellij.psi.PsiFile;
import com.intellij.psi.xml.XmlFile;
import com.intellij.util.IncorrectOperationException;
import com.intellij.util.xml.DomFileElement;
import com.intellij.util.xml.DomManager;
import org.jetbrains.annotations.NonNls;
import org.jetbrains.annotations.NotNull;

public abstract class AbstractEjbJarIntention implements IntentionAction {
  @NonNls
  private static final String EJB_JAR_XML = "ejb-jar.xml";


  @NotNull
  public final String getFamilyName() {
    return "Konaworks EE Intentions";
  }

  public final boolean isAvailable(Project project, Editor editor, PsiFile file) {
    if (EJB_JAR_XML.equals(file.getName())) {
      final DomFileElement<EjbJar> domFileElement = DomManager.getDomManager(file.getProject()).getFileElement((XmlFile) file, EjbJar.class);
      assert domFileElement != null;
      final EjbJar ejbJar = domFileElement.getRootElement();

      return isAvailable(project, editor, ejbJar);
    }
    return false;
  }

  public final void invoke(Project project, Editor editor, PsiFile file) throws IncorrectOperationException {
    final DomFileElement<EjbJar> domFileElement = DomManager.getDomManager(file.getProject()).getFileElement((XmlFile) file, EjbJar.class);
    assert domFileElement != null;
    final EjbJar ejbJar = domFileElement.getRootElement();
    invoke(project, editor, ejbJar);
  }

  public abstract boolean isAvailable(Project project, Editor editor, EjbJar ejbJar);

  public abstract void invoke(Project project, Editor editor, EjbJar ejbJar);
}
